#Summary and conclusions

The species abundance distribution is one of the oldest and most well studied patterns in ecology [@mcgill2007]. Despite the extensive study of this pattern, it remains an open question as to whether the pattern contains enough information to allow the operation of biological processes to be inferred from its shape [@mcgill2007; @harte2011; @white2012; @locey2013; @connolly2014]. I have compiled the largest species abundance distribution dataset ever evaluated and used it to both compare a suite of different models for the SAD and to evaluate whether a particular process can be detected as dominant in structuring a large set of SADs.

In general, I found that it is difficult to infer process from species abundance distributions alone.  Part of the difficulty in identifying pattern generating mechanisms from species abundance distributions is due to the fact that multiple mechanisms have been proposed for each formulation of the species abundance distribution. In other words, it is possible for different processes to yield exactly equivalent models [@pielou1975; @mcgill2007]. Subsuming some of these differences into broad categories such as neutral or non-neutral [sensu @connolly2014] may make it possible to draw inferences on general categories of models. However, my results suggest that it may be difficult to distinguish among even these broad categories of models and their associated distributions, at least in terrestrial systems. In combination with the results of Connolly et al. (2014), this suggests that, in terrestrial systems, there may not be one single suite of processes that have equal importance in all communities, i.e., non-neutral processes may be more important in some communities, but not in others.

Using the largest compliation of species-abundance distributions ever assembled helps to mitigate a potentially important confounding factor when trying to identify pattern generating mechanisms: non-biological variation among samples (sampling intensity, spatial scale, etc.) vs. biological differences.  Applying data from different taxonomic groups and from different geographic regions assists in removing some of the uncertainty relating to non-biological data differences through covering a range of sampling intensities and scales of collection. When results are consistent across datasets using very different sampling approaches, as they were in this study, it provides confidence that methodological differences were not crucial in determining the results [@white2012]. Thus, the agreement in results among these different datasets strongly suggests that biological differences exist between marine vs. terrestrial in the dominance of non-neutral processes. Without a breadth of data in both my study and that of Connolly et al. 2014, it would have been difficult to differentiate biological from non-biological differences in the systems.

A traditional approach to scientific research is to identify general patterns, then pattern generating mechanisms (process), then use those processes to generate predictions.  While this has been the traditional approach, pattern to process to prediction, identification of process may not be necessary for prediction in some cases.  It may be possible to generate robust ecological predictions from general patterns without specific knowledge of the pattern generating mechanisms [@harte2008; @frank2009; @harte2011; @locey2013; @frank2014].  If true, this would mean that process and prediction may be two separate research goals [@mcgill2010mechanisms; @perretti2013].

One criticism of the macroecological approach is that it attempts to replace natural history and field experimentation with entirely computational and observational approaches to experimentation. The increasing amount of data and computational power creates new opportunities to address major ecological questions in a new way. However, while computational techniques and large datasets are a powerful tool for ecology, they are not a panacea. Rather, the macroecological research program addresses different questions from a different perspective than those of traditional ecology, and thus both approaches are vital to continue in the search for pattern generating mechanisms in ecology.

# References
